'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Dialog = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _DomHandler = require('../utils/DomHandler');

var _DomHandler2 = _interopRequireDefault(_DomHandler);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Dialog = exports.Dialog = function (_Component) {
    _inherits(Dialog, _Component);

    function Dialog(props) {
        _classCallCheck(this, Dialog);

        var _this = _possibleConstructorReturn(this, (Dialog.__proto__ || Object.getPrototypeOf(Dialog)).call(this, props));

        _this.state = { visible: props.visible };
        _this.onCloseClick = _this.onCloseClick.bind(_this);
        _this.initDrag = _this.initDrag.bind(_this);
        _this.endDrag = _this.endDrag.bind(_this);
        _this.moveOnTop = _this.moveOnTop.bind(_this);
        return _this;
    }

    _createClass(Dialog, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (this.state.visible !== nextProps.visible) {
                this.setState({ visible: nextProps.visible });
                if (nextProps.visible) this.onShow();else this.onHide();
            }
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps, prevState) {
            if (this.props.visible !== prevProps.visible) {
                if (this.state.visible) this.onShow();else this.onHide();
            }
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (this.state.visible) {
                this.onShow();
            }

            if (this.props.draggable) {
                this.documentDragListener = this.onDrag.bind(this);
                document.addEventListener('mousemove', this.documentDragListener);
            }
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            if (this.documentDragListener) {
                document.removeEventListener('mousemove', this.documentDragListener);
            }
        }
    }, {
        key: 'onShow',
        value: function onShow() {
            this.center();
            _DomHandler2.default.fadeIn(this.container, 250);

            if (this.props.modal) {
                this.enableModality();
            }

            if (this.props.onShow) {
                this.props.onShow();
            }

            this.container.style.zIndex = _DomHandler2.default.getZindex();
        }
    }, {
        key: 'onCloseClick',
        value: function onCloseClick(event) {
            this.hide();
            event.preventDefault();
        }
    }, {
        key: 'onHide',
        value: function onHide() {
            if (this.props.modal) {
                this.disableModality();
            }
        }
    }, {
        key: 'hide',
        value: function hide() {
            this.setState({ visible: false });

            if (this.props.onHide) {
                this.props.onHide();
            }

            if (this.props.modal) {
                this.disableModality();
            }
        }
    }, {
        key: 'center',
        value: function center() {
            var elementWidth = _DomHandler2.default.getOuterWidth(this.container);
            var elementHeight = _DomHandler2.default.getOuterHeight(this.container);
            if (elementWidth === 0 && elementHeight === 0) {
                this.container.style.visibility = 'hidden';
                this.container.style.display = 'block';
                elementWidth = _DomHandler2.default.getOuterWidth(this.container);
                elementHeight = _DomHandler2.default.getOuterHeight(this.container);
                this.container.style.display = 'none';
                this.container.style.visibility = 'visible';
            }
            var viewport = _DomHandler2.default.getViewport();
            var x = (viewport.width - elementWidth) / 2;
            var y = (viewport.height - elementHeight) / 2;

            this.container.style.left = x + 'px';
            this.container.style.top = y + 'px';
        }
    }, {
        key: 'enableModality',
        value: function enableModality() {
            if (!this.mask) {
                this.mask = document.createElement('div');
                this.mask.style.zIndex = _DomHandler2.default.getZindex();
                _DomHandler2.default.addMultipleClasses(this.mask, 'ui-widget-overlay ui-dialog-mask');
                document.body.appendChild(this.mask);
            }
        }
    }, {
        key: 'disableModality',
        value: function disableModality() {
            if (this.mask) {
                document.body.removeChild(this.mask);
                this.mask = null;
            }
        }
    }, {
        key: 'initDrag',
        value: function initDrag(event) {
            if (this.props.draggable) {
                this.dragging = true;
                this.lastPageX = event.pageX;
                this.lastPageY = event.pageY;
            }
        }
    }, {
        key: 'onDrag',
        value: function onDrag(event) {
            if (this.dragging) {
                var deltaX = event.pageX - this.lastPageX;
                var deltaY = event.pageY - this.lastPageY;
                var leftPos = parseFloat(this.container.style.left);
                var topPos = parseFloat(this.container.style.top);

                this.container.style.left = leftPos + deltaX + 'px';
                this.container.style.top = topPos + deltaY + 'px';

                this.lastPageX = event.pageX;
                this.lastPageY = event.pageY;
            }
        }
    }, {
        key: 'endDrag',
        value: function endDrag(event) {
            if (this.props.draggable) {
                this.dragging = false;
            }
        }
    }, {
        key: 'moveOnTop',
        value: function moveOnTop() {
            this.container.style.zIndex = _DomHandler2.default.getZindex();
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var styleClass = (0, _classnames2.default)('ui-dialog ui-widget ui-widget-content ui-corner-all ui-shadow', this.props.className);
            var style = {
                display: this.state.visible ? 'block' : 'none',
                width: this.props.width,
                height: this.props.height
            };
            var footer = this.props.footer && _react2.default.createElement(
                'div',
                { className: 'ui-dialog-footer ui-widget-content' },
                this.props.footer
            );

            return _react2.default.createElement(
                'div',
                { className: styleClass, style: style, ref: function ref(el) {
                        _this2.container = el;
                    }, onMouseDown: this.moveOnTop },
                _react2.default.createElement(
                    'div',
                    { className: 'ui-dialog-titlebar ui-widget-header ui-helper-clearfix ui-corner-top', onMouseDown: this.initDrag, onMouseUp: this.endDrag },
                    _react2.default.createElement(
                        'span',
                        { className: 'ui-dialog-title' },
                        this.props.header
                    ),
                    _react2.default.createElement(
                        'a',
                        { href: '#', role: 'button', className: 'ui-dialog-titlebar-icon ui-dialog-titlebar-close ui-corner-all', onClick: this.onCloseClick },
                        _react2.default.createElement('span', { className: 'fa fa-fw fa-close' })
                    )
                ),
                _react2.default.createElement(
                    'div',
                    { className: 'ui-dialog-content ui-widget-content' },
                    this.props.children
                ),
                footer
            );
        }
    }]);

    return Dialog;
}(_react.Component);

Dialog.defaultProps = {
    header: null,
    footer: null,
    visible: false,
    width: 'auto',
    height: 'auto',
    modal: false,
    onHide: null,
    onShow: null,
    draggable: true
};
Dialog.propTypes = {
    header: _propTypes2.default.any,
    footer: _propTypes2.default.any,
    visible: _propTypes2.default.bool,
    width: _propTypes2.default.string,
    height: _propTypes2.default.string,
    modal: _propTypes2.default.bool,
    onHide: _propTypes2.default.func,
    onShow: _propTypes2.default.func,
    draggable: _propTypes2.default.bool
};