'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Dropdown = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _DomHandler = require('../utils/DomHandler');

var _DomHandler2 = _interopRequireDefault(_DomHandler);

var _ObjectUtils = require('../utils/ObjectUtils');

var _ObjectUtils2 = _interopRequireDefault(_ObjectUtils);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Dropdown = exports.Dropdown = function (_Component) {
    _inherits(Dropdown, _Component);

    function Dropdown(props) {
        _classCallCheck(this, Dropdown);

        var _this = _possibleConstructorReturn(this, (Dropdown.__proto__ || Object.getPrototypeOf(Dropdown)).call(this, props));

        _this.state = { focus: false };
        _this.onClick = _this.onClick.bind(_this);
        _this.onFilterInputClick = _this.onFilterInputClick.bind(_this);
        _this.onInputBlur = _this.onInputBlur.bind(_this);
        _this.onInputFocus = _this.onInputFocus.bind(_this);
        _this.onKeydown = _this.onKeydown.bind(_this);
        _this.onEditableInputClick = _this.onEditableInputClick.bind(_this);
        _this.onEditableInputFocus = _this.onEditableInputFocus.bind(_this);
        return _this;
    }

    _createClass(Dropdown, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.documentClickListener = this.onDocumentClick.bind(this);
            document.addEventListener('click', this.documentClickListener);

            if (this.props.autoWidth) {
                if (!this.props.style || !this.props.style['width'] && !this.props.style['min-width']) {
                    this.container.style.width = this.selectElement.offsetWidth + 32 + 'px';
                }
            }
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            if (this.documentClickListener) {
                document.removeEventListener('click', this.documentClickListener);
            }
        }
    }, {
        key: 'onDocumentClick',
        value: function onDocumentClick() {
            if (!this.selfClick && !this.itemClick && !this.filterClick) {
                this.hide();
            }
            this.filterClick = false;
            this.selfClick = false;
            this.optionClick = false;
        }
    }, {
        key: 'onOptionClick',
        value: function onOptionClick(event, option, index) {
            this.optionClick = true;
            this.highlightOption = option;
            this.selectItem(event, option, index);
            this.hide();
            this.input.focus();
            event.preventDefault();
        }
    }, {
        key: 'selectItem',
        value: function selectItem(event, option, index) {
            if (this.findSelectedOption() !== option) {
                this.props.onChange({
                    originalEvent: event,
                    value: option.value,
                    index: index
                });
            }
        }
    }, {
        key: 'onClick',
        value: function onClick(event) {
            var _this2 = this;

            if (this.props.disabled) {
                return;
            }

            this.selfClick = true;

            if (!this.optionClick) {
                if (this.props.filter) {
                    this.filterInput.focus();
                }

                if (this.panel.offsetParent) {
                    this.input.focus();
                    this.hide();
                } else {
                    this.show();
                    if (this.props.filter) {
                        setTimeout(function () {
                            _this2.filterInput.focus();
                        }, 200);
                    }
                }
            }
        }
    }, {
        key: 'findSelectedOption',
        value: function findSelectedOption() {
            var selectedOption;
            if (this.props.options) {
                var _iteratorNormalCompletion = true;
                var _didIteratorError = false;
                var _iteratorError = undefined;

                try {
                    for (var _iterator = this.props.options[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                        var option = _step.value;

                        if (option.value === this.props.value) {
                            selectedOption = option;
                            break;
                        }
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally {
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return) {
                            _iterator.return();
                        }
                    } finally {
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }
            }

            return selectedOption;
        }
    }, {
        key: 'show',
        value: function show() {
            if (this.props.options && this.props.options.length) {
                this.panel.style.zIndex = _DomHandler2.default.getZindex();
                _DomHandler2.default.relativePosition(this.panel, this.container);
                _DomHandler2.default.fadeIn(this.panel, 250);
                this.panel.style.display = 'block';
                this.bindDocumentClickListener();
            }
            this.input.focus();
        }
    }, {
        key: 'hide',
        value: function hide() {
            this.panel.style.display = 'none';
        }
    }, {
        key: 'onInputFocus',
        value: function onInputFocus(event) {
            this.setState({ focus: true });
        }
    }, {
        key: 'onInputBlur',
        value: function onInputBlur(event) {
            this.setState({ focus: false });
        }
    }, {
        key: 'findOptionIndex',
        value: function findOptionIndex(option) {
            var index = 0;
            if (this.props.options) {
                for (var i = 0; i < this.props.options.length; i++) {
                    if (_ObjectUtils2.default.equals(option, this.props.options[i])) {
                        index = i;
                        break;
                    }
                }
            }
            return index;
        }
    }, {
        key: 'onKeydown',
        value: function onKeydown(event) {
            var highlightItemIndex = this.highlightOption ? this.findOptionIndex(this.highlightOption) : 0;

            switch (event.which) {
                //down
                case 40:
                    if (event.altKey) {
                        this.show();
                    } else {
                        if (highlightItemIndex !== -1) {
                            var nextItemIndex = highlightItemIndex + 1;
                            if (nextItemIndex !== this.props.options.length) {
                                this.highlightOption = this.props.options[nextItemIndex];
                                this.highlightOptionChanged = true;
                            }

                            this.selectItem(event, this.highlightOption);
                        } else {
                            this.highlightOption = this.props.options[0];
                        }
                    }
                    event.preventDefault();
                    break;

                //up
                case 38:
                    if (highlightItemIndex > 0) {
                        var prevItemIndex = highlightItemIndex - 1;
                        this.highlightOption = this.props.options[prevItemIndex];
                        this.highlightOptionChanged = true;
                        this.selectItem(event, this.highlightOption);
                    }

                    event.preventDefault();
                    break;

                //enter
                case 13:
                    if (this.highlightOption) {
                        this.selectItem(event, this.highlightOption);
                        this.hide();
                    }
                    event.preventDefault();
                    break;

                //escape
                case 27:
                    this.hide();
                    event.preventDefault();
                    break;

                //tab
                case 9:
                    this.hide();
                    break;

                //space
                case 32:
                    if (this.panel.style.display === 'block') {
                        if (this.highlightOption) {
                            this.selectItem(event, this.highlightOption);
                            this.hide();
                        }
                    } else {
                        this.show();
                    }
                    event.preventDefault();
                    break;
                default:
                    break;
            }
            this.setState({ highlightOption: this.highlightOption });
        }
    }, {
        key: 'onFilter',
        value: function onFilter(event) {
            var inputValue = event.target.value.toLowerCase();
            if (inputValue && inputValue.length) {
                this.filterValue = inputValue;
                this.activateFilter();
            } else {
                this.filterValue = null;
                this.setState({ filteredOption: this.props.options });
            }
        }
    }, {
        key: 'activateFilter',
        value: function activateFilter() {
            var searchFields = this.props.filterBy.split(',');
            if (this.props.options && this.props.options.length) {
                this.setState({ filteredOption: _ObjectUtils2.default.filter(this.props.options, searchFields, this.filterValue) });
            }
        }
    }, {
        key: 'onFilterInputClick',
        value: function onFilterInputClick(event) {
            this.filterClick = true;
            event.stopPropagation();
        }
    }, {
        key: 'bindDocumentClickListener',
        value: function bindDocumentClickListener() {
            var _this3 = this;

            if (!this.documentClickListener) {
                this.documentClickListener = document.addEventListener('click', function () {
                    if (!_this3.selfClick && !_this3.itemClick) {
                        _this3.panel.style.display = 'none';
                        _this3.unbindDocumentClickListener();
                    }

                    _this3.selfClick = false;
                    _this3.itemClick = false;
                });
            }
        }
    }, {
        key: 'unbindDocumentClickListener',
        value: function unbindDocumentClickListener() {
            if (this.documentClickListener) {
                this.documentClickListener();
                this.documentClickListener = null;
            }
        }
    }, {
        key: 'onEditableInputFocus',
        value: function onEditableInputFocus(event) {
            this.setState({ focus: true });
            this.hide();
        }
    }, {
        key: 'onEditableInputClick',
        value: function onEditableInputClick(event) {
            this.optionClick = false;
            event.stopPropagation();
        }
    }, {
        key: 'onEditable',
        value: function onEditable(event) {
            this.editValue = event.target.value;
            this.props.onChange({
                originalEvent: event,
                value: this.editValue
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var _this4 = this;

            var styleClass = (0, _classnames2.default)('ui-dropdown ui-widget ui-state-default ui-corner-all', this.props.className, {
                'ui-state-disabled': this.props.disabled,
                'ui-state-focus': this.state.focus
            });

            var selectedOption = this.findSelectedOption();
            var label = selectedOption ? selectedOption.label : this.props.options ? this.props.options[0].label : null;
            var listItems, optionElements;
            var filterInput, filter;
            var editable;

            if (this.props.options) {

                var listItemContent;
                var optionMap = this.state.filteredOption ? this.state.filteredOption : this.props.options;

                listItems = optionMap.map(function (option, index) {
                    listItemContent = _this4.props.itemTemplate ? _this4.props.itemTemplate(option) : option.label;
                    var selected = _this4.props.value !== null && _this4.props.value === option.value || _this4.props.value === null && index === 0;
                    var listItemStyleClass = (0, _classnames2.default)('ui-dropdown-item ui-corner-all', { 'ui-state-highlight': selected || _this4.state.highlightOption === option });
                    var listItem = _react2.default.createElement(
                        'li',
                        { className: listItemStyleClass, key: option.value, onClick: function onClick(event) {
                                return _this4.onOptionClick(event, option);
                            }
                        },
                        listItemContent
                    );

                    return listItem;
                });

                optionElements = this.props.options.map(function (option, index) {
                    return _react2.default.createElement(
                        'option',
                        { value: option.value, key: option.value },
                        option.label
                    );
                });
            }

            if (this.props.filter) {
                filterInput = _react2.default.createElement('input', { type: 'text', autoComplete: 'off', className: 'ui-dropdown-filter ui-inputtext ui-widget ui-state-default ui-corner-all',
                    ref: function ref(el) {
                        _this4.filterInput = el;
                    }, placeholder: this.props.filterPlaceholder,
                    onKeyDown: function onKeyDown(event) {
                        return event.which === 13 ? event.preventDefault() : null;
                    } });
                filter = _react2.default.createElement(
                    'div',
                    { className: 'ui-dropdown-filter-container', onChange: function onChange(event) {
                            return _this4.onFilter(event);
                        },
                        onClick: this.onFilterInputClick },
                    filterInput,
                    _react2.default.createElement('span', { className: 'fa fa-search' })
                );
            }
            if (this.props.editable) {
                editable = _react2.default.createElement('input', { type: 'text', className: 'ui-dropdown-label ui-inputtext ui-corner-all', value: selectedOption ? selectedOption.label : this.editValue ? this.editValue : "",
                    ref: function ref(el) {
                        _this4.editableInput = el;
                    }, onChange: function onChange(event) {
                        return _this4.onEditable(event);
                    },
                    onClick: this.onEditableInputClick, placeholder: this.props.placeholder,
                    onFocus: this.onEditableInputFocus, onBlur: this.onInputBlur });
            }

            return _react2.default.createElement(
                'div',
                { className: styleClass, onClick: this.onClick, ref: function ref(el) {
                        _this4.container = el;
                    }, style: this.props.style },
                _react2.default.createElement(
                    'div',
                    { className: 'ui-helper-hidden-accessible' },
                    _react2.default.createElement(
                        'select',
                        { tabIndex: '-1', ref: function ref(el) {
                                _this4.selectElement = el;
                            } },
                        optionElements
                    )
                ),
                _react2.default.createElement(
                    'div',
                    { className: 'ui-helper-hidden-accessible' },
                    _react2.default.createElement('input', { readOnly: true, ref: function ref(el) {
                            _this4.input = el;
                        }, type: 'text', onFocus: this.onInputFocus,
                        onKeyDown: this.onKeydown, onBlur: this.onInputBlur })
                ),
                editable,
                !this.props.editable && _react2.default.createElement(
                    'label',
                    { className: 'ui-dropdown-label ui-inputtext ui-corner-all' },
                    label
                ),
                _react2.default.createElement(
                    'div',
                    { className: 'ui-dropdown-trigger ui-state-default ui-corner-right' },
                    _react2.default.createElement('span', { className: 'fa fa-fw fa-caret-down ui-c' })
                ),
                _react2.default.createElement(
                    'div',
                    { className: 'ui-dropdown-panel ui-widget-content ui-corner-all ui-helper-hidden ui-shadow', ref: function ref(el) {
                            _this4.panel = el;
                        } },
                    filter,
                    _react2.default.createElement(
                        'div',
                        { className: 'ui-dropdown-items-wrapper', style: { maxHeight: this.props.scrollHeight } },
                        _react2.default.createElement(
                            'ul',
                            { className: 'ui-dropdown-items ui-dropdown-list ui-widget-content ui-widget ui-corner-all ui-helper-reset' },
                            listItems
                        )
                    )
                )
            );
        }
    }]);

    return Dropdown;
}(_react.Component);

Dropdown.defaultProps = {
    value: null,
    options: null,
    onChange: null,
    itemTemplate: null,
    style: null,
    className: null,
    autoWidth: true,
    scrollHeight: '200px',
    filter: false,
    filterBy: null,
    filterPlaceholder: null,
    editable: false,
    placeholder: null
};
Dropdown.propTypes = {
    value: _propTypes2.default.any,
    options: _propTypes2.default.array,
    onChange: _propTypes2.default.func,
    itemTemplate: _propTypes2.default.func,
    style: _propTypes2.default.object,
    className: _propTypes2.default.string,
    autoWidth: _propTypes2.default.bool,
    scrollHeight: _propTypes2.default.string,
    filter: _propTypes2.default.bool,
    filterBy: _propTypes2.default.string,
    filterPlaceholder: _propTypes2.default.string,
    editable: _propTypes2.default.bool,
    placeholder: _propTypes2.default.string
};