'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Rating = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Rating = exports.Rating = function (_Component) {
    _inherits(Rating, _Component);

    function Rating(props) {
        _classCallCheck(this, Rating);

        var _this = _possibleConstructorReturn(this, (Rating.__proto__ || Object.getPrototypeOf(Rating)).call(this, props));

        _this.state = { value: _this.props.value };
        return _this;
    }

    _createClass(Rating, [{
        key: 'rate',
        value: function rate(event, i) {
            if (!this.props.readonly && !this.props.disabled) {
                var _value = i + 1;

                if (_value !== this.state.value) {
                    this.props.onChange({
                        originalEvent: event,
                        value: _value
                    });
                    this.setState({ value: _value });
                }
            }
            event.preventDefault();
        }
    }, {
        key: 'clear',
        value: function clear(event) {
            if (!this.props.readonly && !this.props.disabled) {
                var _value = null;
                this.props.onChange({
                    originalEvent: event,
                    value: _value
                });
                this.setState({ value: _value });
            }
            event.preventDefault();
        }
    }, {
        key: 'componentWillMount',
        value: function componentWillMount() {
            this.starsArray = [];
            for (var i = 0; i < this.props.stars; i++) {
                this.starsArray[i] = i;
            }
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            var newValue = nextProps.value;

            if (newValue !== this.state.value) {
                this.setState({ value: newValue });
            }
        }
    }, {
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
            if (nextState.value === this.state.value) {
                return false;
            }

            return true;
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var ratingClass = (0, _classnames2.default)('ui-rating', {
                'ui-state-disabled': this.props.disabled
            });

            var cancel = this.props.cancel && _react2.default.createElement(
                'a',
                { href: '#', onClick: this.clear.bind(this) },
                _react2.default.createElement('span', { className: 'fa fa-ban' })
            ),
                stars = this.starsArray && this.starsArray.map(function (star, index) {
                var iconClass = (0, _classnames2.default)('fa', {
                    'fa-star-o': !_this2.state.value || index >= _this2.state.value,
                    'fa-star': index < _this2.state.value
                });

                return _react2.default.createElement(
                    'a',
                    { href: '#', onClick: function onClick(e) {
                            return _this2.rate(e, index);
                        }, key: 'star_' + index },
                    _react2.default.createElement('span', { className: iconClass })
                );
            });

            return _react2.default.createElement(
                'div',
                { className: ratingClass },
                cancel,
                stars
            );
        }
    }]);

    return Rating;
}(_react.Component);

Rating.defaultProps = {
    value: null,
    disabled: false,
    readonly: false,
    stars: 5,
    cancel: true
};
Rating.propsTypes = {
    value: _propTypes2.default.string,
    disabled: _propTypes2.default.bool,
    readonly: _propTypes2.default.bool,
    stars: _propTypes2.default.number,
    cancel: _propTypes2.default.bool
};